#set up a dataframe of parameter values to cycle through
smoothness_vals <- c(.5,2,10)
range_vals<- c(100,1000,10000)
param_vals_norm <- matrix(rep(0,length(smoothness_vals)*length(range_vals)*4),ncol=4)
index <- 1
for(j in 1:length(smoothness_vals))
{
  for(k in 1:length(range_vals))
  {
    param_vals_norm[index,] <- c(smoothness_vals[j],range_vals[k],0,0)
    index <- index+1
  } 
}

#first, try normal data distribution with unknown scale parameter (inv-gamma prior)
for (index in 1:dim(param_vals_norm)[1])
{
  set.seed(1234)
  print(index)
  smoothness_cur <- param_vals_norm[index,1]
  range_cur <- param_vals_norm[index,2]
  
  basal_cov_mat <- 100*Matern(distance_mat,range=range_cur,smoothness = smoothness_cur)
  
  cur_sd_x <- 1
  cur_sd_y <- 1
  B_cur <- 30*10^(-25)
  cur_basal_sliding <- ess(log.lik.basal,test_Y,basal_cov_mat,1,10000,length(S_x_vec),flag=TRUE)
  
  
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  N_iter <- 1000
  
  deform_mag <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  sliding_mag <-matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  u_bar_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  u_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  x_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  y_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  x_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  y_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  v_bar_samps <-  matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  v_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  basal_sliding_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  sd_x_samps <- rep(0,N_iter)
  sd_y_samps <- rep(0, N_iter)
  B_samps <- rep(0,N_iter)
  
  for(iter in 1:N_iter)
  {
    #update basal sliding
    print(iter)
    C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
    cur_u_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
    cur_v_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
    deform_mag[iter,] <- sqrt((C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec))^2+(C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec))^2)
    sliding_mag[iter,] <- sqrt((exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec))^2+(exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec))^2)
    u_obs_samps[iter,] <- rnorm(n=length(cur_u_bar),mean = cur_u_bar, sd = cur_sd_x)
    v_obs_samps[iter,] <- rnorm(n=length(cur_v_bar),mean = cur_v_bar, sd = cur_sd_y)
    x_squared_errors[iter,] <- (u_obs_samps[iter,]-velocity_x)^2
    y_squared_errors[iter,] <- (v_obs_samps[iter,]-velocity_y)^2
    x_abs_errors[iter,] <- abs(u_obs_samps[iter,]-velocity_x)
    y_abs_errors[iter,] <- abs(v_obs_samps[iter,]-velocity_y)
    cur_var_x <- cur_sd_x^2
    cur_var_y <- cur_sd_y^2
    #update scale parameters
    cur_var_x <- rinvgamma(1, shape= 3+length(S_x_vec)/2, rate = 4+sum((velocity_x-cur_u_bar)^2)/2)
    cur_var_y <- rinvgamma(1, shape= 3+length(S_x_vec)/2, rate = 4+sum((velocity_y-cur_v_bar)^2)/2)
    cur_sd_x <- sqrt(cur_var_x)
    cur_sd_y <- sqrt(cur_var_y)
    cur_basal_sliding <- ess_step(cur_basal_sliding,test_Y,basal_cov_mat)
    
    B_grid <- seq(10,700)*10^(-26)
    B_post <- rep(0,length(B_grid))
    for(i in 1:length(B_grid))
    {
      B_post[i] <- log.lik.B(B_grid[i],test_Y)+log.prior.B(B_grid[i])
    }
    #normalize
    c <- max(B_post)
    sum(exp(B_post-c))
    post_probs <- exp(B_post-c)/sum(exp(B_post-c))
    B_cur <- sample(B_grid,1,replace=TRUE,prob=post_probs)
    
    #store current values
    basal_sliding_samps[iter,] <- cur_basal_sliding
    u_bar_samps[iter,] <- cur_u_bar
    v_bar_samps[iter,] <- cur_v_bar
    sd_x_samps[iter] <- cur_sd_x
    sd_y_samps[iter] <- cur_sd_y
    B_samps[iter] <- B_cur
  }
  
  errors <- cbind(x_squared_errors,y_squared_errors)
  RMSE <- sqrt(mean(errors))
  abs_errors <- mean(cbind(x_abs_errors,y_abs_errors))
  param_vals_norm[index,3] <- RMSE
  param_vals_norm[index, 4] <- abs_errors
}

#set up a data frame of parameter values to cycle through for t this time
smoothness_vals <- c(.5,2,10)
range_vals<- c(100,1000,10000)
dof_vals <- c(3+10^(-4))
param_vals_t <- matrix(rep(0,length(smoothness_vals)*length(range_vals)*length(dof_vals)*5),ncol=5)
index <- 1
for(j in 1:length(smoothness_vals))
{
  for(k in 1:length(range_vals))
  {
    for(l in 1:length(dof_vals))
    {
      param_vals_t[index,] <- c(smoothness_vals[j],range_vals[k],dof_vals[l],0,0)
      index <- index+1
    }
  } 
}

for (index in 1:dim(param_vals_t)[1])
{
  set.seed(1234)
  print(index)
  smoothness_cur <- param_vals_t[index,1]
  range_cur <- param_vals_t[index,2]
  dof <- param_vals_t[index,3]
  basal_cov_mat <- 100*Matern(distance_mat,range=range_cur,smoothness = smoothness_cur)
  B_cur <- 30*10^(-25)
  cur_sd_x <- 1
  cur_sd_y <- 1
  cur_basal_sliding <- ess(log.lik.basal.t,test_Y,basal_cov_mat,1,10000,length(S_x_vec),flag=TRUE)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  N_iter <- 1000
  
  deform_mag <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  deform_ang <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  sliding_mag <-matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  sliding_ang <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  u_bar_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  u_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  x_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  y_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  x_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  y_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  dof_samps <- rep(0,N_iter)
  v_bar_samps <-  matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  v_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  basal_sliding_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
  sd_x_samps <- rep(0,N_iter)
  sd_y_samps <- rep(0, N_iter)
  B_samps <- rep(0,N_iter)
  
  for(iter in 1:N_iter)
  {
    #update basal sliding
    print(iter)
    C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
    cur_u_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
    cur_v_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
    deform_mag[iter,] <- sqrt((C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec))^2+(C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec))^2)
    sliding_mag[iter,] <- sqrt((exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec))^2+(exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec))^2)
    u_obs_samps[iter,] <-cur_sd_x*rt(n=length(cur_u_bar), df=dof)+cur_u_bar
    v_obs_samps[iter,] <- cur_sd_y*rt(n=length(cur_v_bar), df=dof)+cur_v_bar
    x_squared_errors[iter,] <- (u_obs_samps[iter,]-velocity_x)^2
    y_squared_errors[iter,] <- (v_obs_samps[iter,]-velocity_y)^2
    x_abs_errors[iter,] <- abs(u_obs_samps[iter,]-velocity_x)
    y_abs_errors[iter,] <- abs(v_obs_samps[iter,]-velocity_y)
    
    cur_basal_sliding <- ess_step_t(cur_basal_sliding,test_Y,basal_cov_mat)
    #sample B
    B_grid <- seq(10,700)*10^(-26)
    B_post <- rep(0,length(B_grid))
    for(i in 1:length(B_grid))
    {
      B_post[i] <- log.lik.B.t(B_grid[i],test_Y)+log.prior.B(B_grid[i])
    }
    #normalize
    c <- max(B_post)
    sum(exp(B_post-c))
    post_probs <- exp(B_post-c)/sum(exp(B_post-c))
    B_cur <- sample(B_grid,1,replace=TRUE,prob=post_probs)
    
    #sample sd_x
    sd_x_grid <- seq(.1,10,by=.1)
    sd_x_post <- rep(0,length(sd_x_grid))
    for(i in 1:length(sd_x_grid))
    {
      sd_x_post[i] <- log.lik.scale.x.t(sd_x_grid[i],test_Y)+log.prior.sd.t(sd_x_grid[i])
    }
    #normalize
    c <- max(sd_x_post)
    sum(exp(sd_x_post-c))
    post_probs <- exp(sd_x_post-c)/sum(exp(sd_x_post-c))
    cur_sd_x <- sample(sd_x_grid,1,replace=TRUE,prob=post_probs)
    
    #sample_sd_y
    sd_y_grid <- seq(.1,10,by=.1)
    sd_y_post <- rep(0,length(sd_y_grid))
    for(i in 1:length(sd_y_grid))
    {
      sd_y_post[i] <- log.lik.scale.y.t(sd_y_grid[i],test_Y)+log.prior.sd.t(sd_y_grid[i])
    }
    #normalize
    c <- max(sd_y_post)
    sum(exp(sd_y_post-c))
    post_probs <- exp(sd_y_post-c)/sum(exp(sd_y_post-c))
    cur_sd_y <- sample(sd_y_grid,1,replace=TRUE,prob=post_probs)
    
    basal_sliding_samps[iter,] <- cur_basal_sliding
    u_bar_samps[iter,] <- cur_u_bar
    v_bar_samps[iter,] <- cur_v_bar
    sd_x_samps[iter] <- cur_sd_x
    sd_y_samps[iter] <- cur_sd_y
    B_samps[iter] <- B_cur
  }
  errors <- cbind(x_squared_errors,y_squared_errors)
  RMSE <- sqrt(mean(errors))
  abs_errors <- mean(cbind(x_abs_errors,y_abs_errors))
  param_vals_t[index,4] <- RMSE
  param_vals_t[index, 5] <- abs_errors
}