set.seed(1234)
N_iter <- 450000
burnin <- 50001
range_cur <- 100
smoothness_cur <- .5
B_cur <- 30*10^(-25)
basal_cov_mat <- 100*Matern(distance_mat,range=range_cur,smoothness = smoothness_cur)
cur_basal_sliding <- ess(log.lik.basal,test_Y,basal_cov_mat,1,10000,length(S_x_vec),flag=TRUE)
cur_sd_x <- 1
cur_sd_y <- 1

C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
deform_mag <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
deform_ang <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
sliding_mag <-matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
sliding_ang <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
u_bar_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
u_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
x_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
y_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
x_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
y_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
v_bar_samps <-  matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
v_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
basal_sliding_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
sd_x_samps <- rep(0,N_iter)
sd_y_samps <- rep(0, N_iter)
B_samps <- rep(0,N_iter)

for(iter in 1:N_iter)
{
  #update basal sliding
  print(iter)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  cur_u_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  cur_v_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  deform_mag[iter,] <- sqrt((C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec))^2+(C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec))^2)
  sliding_mag[iter,] <- sqrt((exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec))^2+(exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec))^2)
  u_obs_samps[iter,] <- rnorm(n=length(cur_u_bar),mean = cur_u_bar, sd = cur_sd_x)
  v_obs_samps[iter,] <- rnorm(n=length(cur_v_bar),mean = cur_v_bar, sd = cur_sd_y)
  x_squared_errors[iter,] <- (u_obs_samps[iter,]-velocity_x)^2
  y_squared_errors[iter,] <- (v_obs_samps[iter,]-velocity_y)^2
  x_abs_errors[iter,] <- abs(u_obs_samps[iter,]-velocity_x)
  y_abs_errors[iter,] <- abs(v_obs_samps[iter,]-velocity_y)
  cur_var_x <- cur_sd_x^2
  cur_var_y <- cur_sd_y^2
  #update scale parameters
  cur_var_x <- rinvgamma(1, shape= 3+length(S_x_vec)/2, rate = 4+sum((velocity_x-cur_u_bar)^2)/2)
  cur_var_y <- rinvgamma(1, shape= 3+length(S_x_vec)/2, rate = 4+sum((velocity_y-cur_v_bar)^2)/2)
  cur_sd_x <- sqrt(cur_var_x)
  cur_sd_y <- sqrt(cur_var_y)
  cur_basal_sliding <- ess_step(cur_basal_sliding,test_Y,basal_cov_mat)
  B_grid <- seq(10,700)*10^(-26)
  B_post <- rep(0,length(B_grid))
  for(i in 1:length(B_grid))
  {
    B_post[i] <- log.lik.B(B_grid[i],test_Y)+log.prior.B(B_grid[i])
  }
  #normalize
  c <- max(B_post)
  sum(exp(B_post-c))
  post_probs <- exp(B_post-c)/sum(exp(B_post-c))
  B_cur <- sample(B_grid,1,replace=TRUE,prob=post_probs)
  
  #store current values
  basal_sliding_samps[iter,] <- cur_basal_sliding
  u_bar_samps[iter,] <- cur_u_bar
  v_bar_samps[iter,] <- cur_v_bar
  sd_x_samps[iter] <- cur_sd_x
  sd_y_samps[iter] <- cur_sd_y
  B_samps[iter] <- B_cur
}

#chop off burn-in
B_samps <- B_samps[burnin:N_iter]
u_bar_samps <- u_bar_samps[burnin:N_iter,]
v_bar_samps <- v_bar_samps[burnin:N_iter,]
basal_sliding_samps <- basal_sliding_samps[burnin:N_iter,]
sd_x_samps <- sd_x_samps[burnin:N_iter]
sd_y_samps <- sd_y_samps[burnin:N_iter]
deform_mag <- deform_mag[burnin:N_iter,]
sliding_mag <- sliding_mag[burnin:N_iter,]

shapiro.test(velocity_x-colMeans(u_bar_samps))
resid_x_norm <- velocity_x-colMeans(u_bar_samps)
shapiro.test(velocity_y-colMeans(v_bar_samps))
resid_y_norm <- velocity_y-colMeans(v_bar_samps)

mcmc_dat <- as.mcmc(cbind(B_samps/(10^(-25)),sd_x_samps,sd_y_samps, exp(basal_sliding_samps)))
mean_x_vel <- colMeans(u_bar_samps)
mean_y_vel <- colMeans(v_bar_samps)
mean_deform <- colMeans(deform_mag)
mean_sliding <- colMeans(sliding_mag)
save(mcmc_dat,mean_x_vel, mean_y_vel,mean_deform, mean_sliding, file = '400000sampsnormNEW.RData')
