#SV residual analysis
load('400000sampsnormNEW.RData')

mean_scale_x <- mean(mcmc_dat[,2])
mean_scale_y <- mean(mcmc_dat[,3])
scaled_resid_x_norm  <- (velocity_x -mean_x_vel)/mean_scale_x
scaled_resid_y_norm  <- (velocity_y -mean_y_vel)/mean_scale_y
sample_q_x_norm <- quantile(scaled_resid_x_norm, prob=ppoints(25))
theor_q_x_norm <- qnorm(ppoints(25), mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)
sample_q_y_norm <- quantile(scaled_resid_y_norm, prob=ppoints(25))
theor_q_y_norm <- qnorm(ppoints(25), mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE)

#Shapiro-Wilk test for normality
shapiro.test(scaled_resid_x_norm)
shapiro.test(scaled_resid_y_norm)

#scale t residuals to get to unscaled theoretical t distribution with 3+10^(-4) dof
load('400000sampstNEW.RData')
dof<- 3+10^(-4)

mean_scale_x <- mean(mcmc_dat[,2])
mean_scale_y <- mean(mcmc_dat[,3])
scaled_resid_x_t  <- (velocity_x -mean_x_vel)/mean_scale_x
scaled_resid_y_t  <- (velocity_y -mean_y_vel)/mean_scale_y

sample_q_x_t <- quantile(scaled_resid_x_t, prob=ppoints(25))
theor_q_x_t <- qt(ppoints(25), df = dof, lower.tail = TRUE, log.p = FALSE)
sample_q_y_t <- quantile(scaled_resid_y_t, prob=ppoints(25))
theor_q_y_t <- qt(ppoints(25), df = dof,lower.tail = TRUE, log.p = FALSE)

#QQ plots for standardized residuals
par(mfrow=c(2,2))
#par(mfrow=c(1,2))
par(mar = c(6,6,6,6))
plot(theor_q_x_norm,sample_q_x_norm,xlim= c(-3,3),ylim=c(-3,3), xlab='Theoretical quantile', ylab = 'Sample quantile', main = ' Normal QQ plot for x-velocity residuals', cex = .65, cex.main = 1.25, cex.lab = 1.25, cex.axis = 1.25)
abline(v = 0)
abline(h = 0)
abline(a = 0, b = 1)
par(mar = c(6,6,6,6))
plot(theor_q_y_norm,sample_q_y_norm,xlim= c(-3,3),ylim=c(-3,3), xlab = 'Theoretical quantile', ylab = 'Sample quantile', main = 'Normal QQ plot for y-velocity residuals', cex = .65, cex.main = 1.25, cex.lab = 1.25, cex.axis = 1.25)
abline(v = 0)
abline(h = 0)
abline(a = 0, b = 1)

#par(mfrow=c(1,2))
par(mar = c(6,6,6,6))
plot(theor_q_x_t,sample_q_x_t,xlim= c(-7,7),ylim=c(-7,7), xlab='Theoretical quantile', ylab = 'Sample quantile', main = 't QQ plot for x-velocity residuals', cex = .65, cex.main = 1.25, cex.lab = 1.25, cex.axis = 1.25)
abline(v = 0)
abline(h = 0)
abline(a = 0, b = 1)
par(mar = c(6,6,6,6))
plot(theor_q_y_t,sample_q_y_t,xlim= c(-5,5),ylim=c(-5,5), xlab = 'Theoretical quantile', ylab = 'Sample quantile', main = 't QQ plot for y-velocity residuals', cex = .65, cex.main = 1.25, cex.lab = 1.25, cex.axis = 1.25)
abline(v = 0)
abline(h = 0)
abline(a = 0, b = 1)
