set.seed(1234)
N_iter <- 450000
burnin <- 50001
smoothness_cur <- 10
range_cur <- 100
dof <- 3+10^(-4)
basal_cov_mat <- 75*Matern(distance_mat,range=range_cur,smoothness = smoothness_cur)
B_cur <- 30*10^(-25)
cur_sd_x <- 1
cur_sd_y <- 1
cur_basal_sliding <- ess(log.lik.basal.t,test_Y,basal_cov_mat,1,10000,length(S_x_vec),flag=TRUE)

C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)


deform_mag <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
sliding_mag <-matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
u_bar_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
u_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
x_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
y_squared_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
x_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
y_abs_errors <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
dof_samps <- rep(0,N_iter)
v_bar_samps <-  matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
v_obs_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
basal_sliding_samps <- matrix(rep(0, N_iter*length(S_x_vec)),ncol = length(S_x_vec))
sd_x_samps <- rep(0,N_iter)
sd_y_samps <- rep(0, N_iter)
B_samps <- rep(0,N_iter)

for(iter in 1:N_iter)
{
  #update basal sliding
  print(iter)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  cur_u_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  cur_v_bar <- exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  deform_mag[iter,] <- sqrt((C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec))^2+(C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec))^2)
  sliding_mag[iter,] <- sqrt((exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_x_vec))^2+(exp(cur_basal_sliding)*(-rho*g_const*thickness_vals*S_y_vec))^2)
  u_obs_samps[iter,] <- cur_sd_x*rt(n=length(cur_u_bar), df=dof)+cur_u_bar
  v_obs_samps[iter,] <- cur_sd_y*rt(n=length(cur_v_bar), df=dof)+cur_v_bar
  x_squared_errors[iter,] <- (u_obs_samps[iter,]-velocity_x)^2
  y_squared_errors[iter,] <- (v_obs_samps[iter,]-velocity_y)^2
  x_abs_errors[iter,] <- abs(u_obs_samps[iter,]-velocity_x)
  y_abs_errors[iter,] <- abs(v_obs_samps[iter,]-velocity_y)
  cur_basal_sliding <- ess_step_t(cur_basal_sliding,test_Y,basal_cov_mat)
  
  B_grid <- seq(10,700)*10^(-26)
  B_post <- rep(0,length(B_grid))
  for(i in 1:length(B_grid))
  {
    B_post[i] <- log.lik.B.t(B_grid[i],test_Y)+log.prior.B.NEW(B_grid[i])
  }
  #normalize
  c <- max(B_post)
  sum(exp(B_post-c))
  post_probs <- exp(B_post-c)/sum(exp(B_post-c))
  B_cur <- sample(B_grid,1,replace=TRUE,prob=post_probs)
  
  #sample sd_x
  sd_x_grid <- seq(.1,5,by=.1)
  sd_x_post <- rep(0,length(sd_x_grid))
  for(i in 1:length(sd_x_grid))
  {
    sd_x_post[i] <- log.lik.scale.x.t(sd_x_grid[i],test_Y)+log.prior.sd.t(sd_x_grid[i])
  }
  #normalize
  c <- max(sd_x_post)
  sum(exp(sd_x_post-c))
  post_probs <- exp(sd_x_post-c)/sum(exp(sd_x_post-c))
  cur_sd_x <- sample(sd_x_grid,1,replace=TRUE,prob=post_probs)
  
  #sample_sd_y
  sd_y_grid <- seq(.1,5,by=.1)
  sd_y_post <- rep(0,length(sd_y_grid))
  for(i in 1:length(sd_y_grid))
  {
    sd_y_post[i] <- log.lik.scale.y.t(sd_y_grid[i],test_Y)+log.prior.sd.t(sd_y_grid[i])
  }
  #normalize
  c <- max(sd_y_post)
  sum(exp(sd_y_post-c))
  post_probs <- exp(sd_y_post-c)/sum(exp(sd_y_post-c))
  cur_sd_y <- sample(sd_y_grid,1,replace=TRUE,prob=post_probs)

  basal_sliding_samps[iter,] <- cur_basal_sliding
  u_bar_samps[iter,] <- cur_u_bar
  v_bar_samps[iter,] <- cur_v_bar
  sd_x_samps[iter] <- cur_sd_x
  sd_y_samps[iter] <- cur_sd_y
  B_samps[iter] <- B_cur
}

#chop off burn-in
B_samps <- B_samps[burnin:N_iter]
u_bar_samps <- u_bar_samps[burnin:N_iter,]
v_bar_samps <- v_bar_samps[burnin:N_iter,]
basal_sliding_samps <- basal_sliding_samps[burnin:N_iter,]
sd_x_samps <- sd_x_samps[burnin:N_iter]
sd_y_samps <- sd_y_samps[burnin:N_iter]
deform_mag <- deform_mag[burnin:N_iter,]
sliding_mag <- sliding_mag[burnin:N_iter,]

mcmc_dat <- as.mcmc(cbind(B_samps/(10^(-25)),sd_x_samps,sd_y_samps, exp(basal_sliding_samps)))
mean_x_vel <- colMeans(u_bar_samps)
mean_y_vel <- colMeans(v_bar_samps)
mean_deform <- colMeans(deform_mag)
mean_sliding <- colMeans(sliding_mag)
save(mcmc_dat,mean_x_vel, mean_y_vel,mean_deform, mean_sliding, file = '400000sampstNEWsens.RData')