#prior_sensitivity

prior_samps <- rnorm(10^5, mean = 35, sd = 30)
prior_samps <- prior_samps[-which(prior_samps < 1)]
prior_samps1 <- prior_samps[-which(prior_samps > 70)]
prior_samps2 <- rinvgamma(10^5, shape = 3, rate = 70)

load('400000sampstNEW.RData')
B_samps_orig <- mcmc_dat[,1]
load('400000sampstNEWsens.RData')
B_samps_new <- mcmc_dat[,1]

#plotting
par(mfrow = c(1,1))
par(mar = c(6, 6, 6, 6)) 
plot(density(B_samps_orig),xlim=c(5,65),col = 'red',main = 'Posteriors for ice-softness parameter', xlab=expression('Ice softness (10'^-25*'s'^-1*'Pa'^-3*')'),lwd=2,lty=1, ylim = c(0,.5),cex.lab = 1.5, cex.main = 1.5, cex.axis = 1.25)
points(density(B_samps_new),xlim=c(5,65),col = 'blue',lwd=2,type='l',lty=2)
points(density(prior_samps1),xlim=c(5,65),col = 'brown',lwd=2,type='l',lty=3)
points(density(prior_samps2),xlim=c(5,65),col = 'black',lwd=2,type='l',lty=4)
legend(30,.3, lty=c(1,2,3,4),legend=c('original posterior','new posterior','original prior: truncated normal','alternate prior: inverse-gamma'),col=c('red','blue','brown','black'), cex = 1.5)


#observed versus posterior mean of x and y surface velocities (plot)
par(mfrow = c(1,2))
par(mar = c(6,6,6,6))
plot(velocity_x,mean_x_vel,xlim=c(-100,100),ylim=c(-100,100), xlab = expression('Observed x velocity (ma'^-1*')'), ylab = expression('Posterior mean of x velocity (ma'^-1*')'),main='Posterior mean versus observed x velocity',cex.lab = 1.75, cex.main = 1.75, cex.axis = 1.5,cex = .5,pch=1)
abline(a=0,b=1,col='red')
abline(v=0)
abline(h=0)

#
plot(velocity_y,mean_y_vel,xlim=c(-100,100),ylim=c(-100,100),xlab = expression('Observed y velocity (ma'^-1*')'), ylab = expression('Posterior mean of y velocity (ma'^-1*')'),main='Posterior mean versus observed y velocity',cex.lab = 1.75, cex.main = 1.75, cex.axis = 1.5, cex= .5,pch=1)
par(mar = c(6,6,6,6))
abline(a=0,b=1,col='red')
abline(v=0)
abline(h=0)



